# CbcBranchingObject Class Reference

Abstract branching object base class Now just difference with OsiBranchingObject. More...

`#include <CbcBranchingObject.hpp>`

Inheritance diagram for CbcBranchingObject:
[legend]
Collaboration diagram for CbcBranchingObject:
[legend]

List of all members.

## Public Member Functions
| CbcBranchingObject ()
| Default Constructor.
| CbcBranchingObject (CbcModel *model, int variable, int way, double value)
| Constructor.
| CbcBranchingObject (const CbcBranchingObject &)
| Copy constructor.
CbcBranchingObject & | operator= (const CbcBranchingObject &rhs)
| Assignment operator.
virtual CbcBranchingObject * | clone () const =0
| Clone.
virtual | ~CbcBranchingObject ()
| Destructor.
virtual int | fillStrongInfo (CbcStrongInfo &)
| Some branchingObjects may claim to be able to skip strong branching.
void | resetNumberBranchesLeft ()
| Reset number of branches left to original.
void | setNumberBranches (int value)
| Set number of branches to do.
virtual double | branch ()=0
| Execute the actions required to branch, as specified by the current state of the branching object, and advance the object's state.
virtual double | branch (OsiSolverInterface *)
| Execute the actions required to branch, as specified by the current state of the branching object, and advance the object's state.
virtual void | fix (OsiSolverInterface *, double *, double *, int) const
| Update bounds in solver as in 'branch' and update given bounds.
virtual bool | tighten (OsiSolverInterface *)
| Change (tighten) bounds in object to reflect bounds in solver.
virtual void | previousBranch ()
| Reset every information so that the branching object appears to point to the previous child.
virtual void | print () const
| Print something about branch - only if log level high.
int | variable () const
| Index identifying the associated CbcObject within its class.
int | way () const
| Get the state of the branching object.
void | way (int way)
| Set the state of the branching object.
void | setModel (CbcModel *model)
| update model
CbcModel * | model () const
| Return model.
CbcObject * | object () const
| Return pointer back to object which created.
void | setOriginalObject (CbcObject *object)
| Set pointer back to object which created.
virtual CbcBranchObjType | type () const =0
| Return the type (an integer identifier) of `this`.
virtual int | compareOriginalObject (const CbcBranchingObject *brObj) const
| Compare the original object of `this` with the original object of `brObj`.
virtual CbcRangeCompare | compareBranchingObject (const CbcBranchingObject *brObj, const bool replaceIfOverlap=false)=0
| Compare the `this` with `brObj`.
## Protected Attributes
CbcModel * | model_
| The model that owns this branching object.
CbcObject * | originalCbcObject_
| Pointer back to object which created.
int | variable_
| Branching variable (0 is first integer).
int | way_
| The state of the branching object.

## Detailed Description

Abstract branching object base class Now just difference with OsiBranchingObject.

In the abstract, an CbcBranchingObject contains instructions for how to branch. We want an abstract class so that we can describe how to branch on simple objects (e.g., integers) and more exotic objects (e.g., cliques or hyperplanes).

The branch() method is the crucial routine: it is expected to be able to step through a set of branch arms, executing the actions required to create each subproblem in turn. The base class is primarily virtual to allow for a wide range of problem modifications.

See CbcObject for an overview of the three classes (CbcObject, CbcBranchingObject, and CbcBranchDecision) which make up cbc's branching model.

Definition at line 53 of file CbcBranchingObject.hpp.

## Constructor & Destructor Documentation

CbcBranchingObject::CbcBranchingObject | ( |  | ) |

Default Constructor.

CbcBranchingObject::CbcBranchingObject | ( | CbcModel * | model,
|  | int | variable,
|  | int | way,
|  | double | value |
| ) |  |  |

Constructor.

CbcBranchingObject::CbcBranchingObject | ( | const CbcBranchingObject & |  | ) |

Copy constructor.

virtual CbcBranchingObject::~CbcBranchingObject | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

CbcBranchingObject& CbcBranchingObject::operator= | ( | const CbcBranchingObject & | rhs | ) |

Assignment operator.

Reimplemented from OsiBranchingObject.

Reimplemented in CbcLinkBranchingObject, CbcCutBranchingObject, CbcDynamicPseudoCostBranchingObject, CbcLotsizeBranchingObject, CbcCliqueBranchingObject, CbcLongCliqueBranchingObject, CbcDummyBranchingObject, CbcFixingBranchingObject, CbcNWayBranchingObject, CbcIntegerBranchingObject, CbcIntegerPseudoCostBranchingObject, and CbcSOSBranchingObject.

virtual CbcBranchingObject* CbcBranchingObject::clone | ( |  | ) | const`[pure virtual]`

Clone.

Implements OsiBranchingObject.

Implemented in CbcLinkBranchingObject, CbcCutBranchingObject, CbcDynamicPseudoCostBranchingObject, CbcLotsizeBranchingObject, CbcCliqueBranchingObject, CbcLongCliqueBranchingObject, CbcDummyBranchingObject, CbcFixingBranchingObject, CbcNWayBranchingObject, CbcIntegerBranchingObject, CbcIntegerPseudoCostBranchingObject, and CbcSOSBranchingObject.

virtual int CbcBranchingObject::fillStrongInfo | ( | CbcStrongInfo & |  | ) | `[inline, virtual]`

Some branchingObjects may claim to be able to skip strong branching.

If so they have to fill in CbcStrongInfo. The object mention in incoming CbcStrongInfo must match. Returns nonzero if skip is wanted

Reimplemented in CbcDynamicPseudoCostBranchingObject.

Definition at line 79 of file CbcBranchingObject.hpp.

void CbcBranchingObject::resetNumberBranchesLeft | ( |  | ) | `[inline]`

Reset number of branches left to original.

Definition at line 83 of file CbcBranchingObject.hpp.

void CbcBranchingObject::setNumberBranches | ( | int | value | ) | `[inline]`

Set number of branches to do.

Definition at line 87 of file CbcBranchingObject.hpp.

virtual double CbcBranchingObject::branch | ( |  | ) | `[pure virtual]`

Execute the actions required to branch, as specified by the current state of the branching object, and advance the object's state.

Mainly for diagnostics, whether it is true branch or strong branching is also passed. Returns change in guessed objective on next branch

Reimplemented from OsiBranchingObject.

Implemented in CbcLinkBranchingObject, CbcCutBranchingObject, CbcDynamicPseudoCostBranchingObject, CbcLotsizeBranchingObject, CbcCliqueBranchingObject, CbcLongCliqueBranchingObject, CbcDummyBranchingObject, CbcFixingBranchingObject, CbcNWayBranchingObject, CbcIntegerBranchingObject, CbcIntegerPseudoCostBranchingObject, and CbcSOSBranchingObject.

virtual double CbcBranchingObject::branch | ( | OsiSolverInterface * |  | ) | `[inline, virtual]`

Execute the actions required to branch, as specified by the current state of the branching object, and advance the object's state.

Mainly for diagnostics, whether it is true branch or strong branching is also passed. Returns change in guessed objective on next branch

Implements OsiBranchingObject.

Definition at line 105 of file CbcBranchingObject.hpp.

virtual void CbcBranchingObject::fix | ( | OsiSolverInterface * | ,
|  | double * | ,
|  | double * | ,
|  | int |  |
| ) |  |  | const`[inline, virtual]`

Update bounds in solver as in 'branch' and update given bounds.

branchState is -1 for 'down' +1 for 'up'

Reimplemented in CbcIntegerBranchingObject, and CbcSOSBranchingObject.

Definition at line 110 of file CbcBranchingObject.hpp.

virtual bool CbcBranchingObject::tighten | ( | OsiSolverInterface * |  | ) | `[inline, virtual]`

Change (tighten) bounds in object to reflect bounds in solver.

Return true if now fixed

Reimplemented in CbcIntegerBranchingObject.

Definition at line 116 of file CbcBranchingObject.hpp.

virtual void CbcBranchingObject::previousBranch | ( |  | ) | `[inline, virtual]`

Reset every information so that the branching object appears to point to the previous child.

This method does not need to modify anything in any solver.

Reimplemented in CbcSOSBranchingObject.

Definition at line 121 of file CbcBranchingObject.hpp.

virtual void CbcBranchingObject::print | ( |  | ) | const`[inline, virtual]`

Print something about branch - only if log level high.

Definition at line 130 of file CbcBranchingObject.hpp.

int CbcBranchingObject::variable | ( |  | ) | const`[inline]`

Index identifying the associated CbcObject within its class.

The name is misleading, and typically the index will not refer directly to a variable. Rather, it identifies an CbcObject within the class of similar CbcObjects

E.g., for an CbcSimpleInteger, variable() is the index of the integer variable in the set of integer variables (not the index of the variable in the set of all variables).

Definition at line 143 of file CbcBranchingObject.hpp.

int CbcBranchingObject::way | ( |  | ) | const`[inline]`

Get the state of the branching object.

Returns a code indicating the active arm of the branching object. The precise meaning is defined in the derived class.

See also:
  way_

Definition at line 154 of file CbcBranchingObject.hpp.

void CbcBranchingObject::way | ( | int | way | ) | `[inline]`

Set the state of the branching object.

See way()

Definition at line 162 of file CbcBranchingObject.hpp.

void CbcBranchingObject::setModel | ( | CbcModel * | model | ) | `[inline]`

update model

Definition at line 167 of file CbcBranchingObject.hpp.

CbcModel* CbcBranchingObject::model | ( |  | ) | const`[inline]`

Return model.

Definition at line 171 of file CbcBranchingObject.hpp.

CbcObject* CbcBranchingObject::object | ( |  | ) | const`[inline]`

Return pointer back to object which created.

Reimplemented in CbcDynamicPseudoCostBranchingObject.

Definition at line 176 of file CbcBranchingObject.hpp.

void CbcBranchingObject::setOriginalObject | ( | CbcObject * | object | ) | `[inline]`

Set pointer back to object which created.

Definition at line 180 of file CbcBranchingObject.hpp.

virtual CbcBranchObjType CbcBranchingObject::type | ( |  | ) | const`[pure virtual]`

Return the type (an integer identifier) of `this`.

See definition of CbcBranchObjType above for possibilities

Implemented in CbcLinkBranchingObject, CbcCutBranchingObject, CbcDynamicPseudoCostBranchingObject, CbcLotsizeBranchingObject, CbcCliqueBranchingObject, CbcLongCliqueBranchingObject, CbcDummyBranchingObject, CbcFixingBranchingObject, CbcNWayBranchingObject, CbcIntegerBranchingObject, CbcIntegerPseudoCostBranchingObject, and CbcSOSBranchingObject.

virtual int CbcBranchingObject::compareOriginalObject | ( | const CbcBranchingObject * | brObj | ) | const`[inline, virtual]`

Compare the original object of `this` with the original object of `brObj`.

Assumes that there is an ordering of the original objects. This method should be invoked only if `this` and brObj are of the same type. Return negative/0/positive depending on whether `this` is smaller/same/larger than the argument.

Definition at line 199 of file CbcBranchingObject.hpp.

virtual CbcRangeCompare CbcBranchingObject::compareBranchingObject | ( | const CbcBranchingObject * | brObj,
|  | const bool | replaceIfOverlap = `false` |
| ) |  |  | `[pure virtual]`

Compare the `this` with `brObj`.

`this` and `brObj` must be of the same type and must have the same original object, but they may have different feasible regions. Return the appropriate CbcRangeCompare value (first argument being the sub/superset if that's the case). In case of overlap (and if `replaceIfOverlap` is true) replace the current branching object with one whose feasible region is the overlap.

## Member Data Documentation

CbcModel* CbcBranchingObject::model_`[protected]`

The model that owns this branching object.

Definition at line 218 of file CbcBranchingObject.hpp.

CbcObject* CbcBranchingObject::originalCbcObject_`[protected]`

Pointer back to object which created.

Definition at line 220 of file CbcBranchingObject.hpp.

int CbcBranchingObject::variable_`[protected]`

Branching variable (0 is first integer).

Definition at line 223 of file CbcBranchingObject.hpp.

int CbcBranchingObject::way_`[protected]`

The state of the branching object.

Specifies the active arm of the branching object. Coded as -1 to take the `down' arm, +1 for the `up' arm. `Down' and `up' are defined based on the natural meaning (floor and ceiling, respectively) for a simple integer. The precise meaning is defined in the derived class.

Definition at line 232 of file CbcBranchingObject.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Cbc-2.8.0/Cbc/src/CbcBranchingObject.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines